//****************************************************************************************************
// file mod_note.cpp
#include <libce.h>

// contatore 0 dello 8259 collegato al piedino n. 0 dello IO APIC
// (in alcuni emulatori, tale contatore risulta collegato al piedino n. 2

const ioaddr iSPR = 0x61;
const ioaddr iCWR = 0x43;
const ioaddr iCTR0_LSB = 0x40;			// contatore 0
const ioaddr iCTR0_MSB = 0x40;			// contatore 0
const ioaddr iCTR2_LSB = 0x42;			// contatore 2
const ioaddr iCTR2_MSB = 0x42;			// contatore 2

void ini_CONT_2()
{
	outputb(0xB6, iCWR);
}

extern "C" void a_nota();				// indirizzo da porre nel gate 241
void ini()
{
	ini_CONT_2();
	gate_init(243, &a_nota);
}

extern "C" void c_nota(natw cc)
{
	outputb(cc, iCTR2_LSB);			// contatore 2: costante cc
	outputb(cc >> 8, iCTR2_MSB);
	outputb(3, iSPR);			// abilita suono
	delay(5);
	outputb(0, iSPR);			// abilita suono
}
//****************************************************************************************************
