//***************************************************************************************************
// file mode_wdma.cpp
#include <libce.h>

const ioaddr iBR = 0x01F0;
const ioaddr iERR = 0x01F1;
const ioaddr iSCR = 0x01F2;
const ioaddr iSNR = 0x01F3;
const ioaddr iCNL = 0x01F4;
const ioaddr iCNH = 0x01F5;
const ioaddr iHND = 0x01F6;
const ioaddr iCMD = 0x01F7;
const ioaddr iSTS = 0x01F7;
const ioaddr iDCR = 0x03F6;
const ioaddr iASR = 0x03F6;

ioaddr iBMCMD;	
ioaddr iBMSTR;
ioaddr iBMDTPR;

const natl sincr= 11;
natl prd[2];

void cerca_bm(natb& dev, natb& fun)
{	for (dev = 0; dev < 32; dev++)
		for (fun = 0; fun < 8; fun++)
			if (pci_read_confw(0, dev, fun, 10) == 0x0101)
				return; 
}

void init_bm() 
{	natl base;  natw cmd; natb bus = 0, dev, fun;
	cerca_bm(dev, fun);
	base = pci_read_confl(bus, dev, fun, 32); 	
	base &= 0xFFFFFFFE; 
	iBMCMD = base;
	iBMSTR = base + 0x2;
	iBMDTPR = base + 0x4;
	cmd = pci_read_confw(bus, dev, fun, 4); 
	pci_write_confw(bus, dev, fun, 4, cmd | 0x0005);
}
extern "C" void a_go_wdma();
extern "C" void a_driver_wdma();
void ini()
{	init_bm();
	gate_init(251, &a_go_wdma);
	gate_init(51, &a_driver_wdma);
	apic_set_VECT(14, 51);
	apic_set_MIRQ(14, false);
}

extern "C" void c_go_wdma(natl indse, natb nn, natb vv[])
{	natb work; natq ww;

	// comandi per il bus master PCI (ponte ATA-PCI) 
	ww = reinterpret_cast<natq>(&vv[0]);
	prd[0] = static_cast<natl>(ww);
	prd[1] = 0x80000000 | nn*512;
	ww = reinterpret_cast<natq>(&prd[0]);
	outputl(static_cast<natl>(ww), iBMDTPR); 
	inputb(iBMCMD, work);
	work &= 0xF7;				    // bit n. 3 di BMCMD posto a 0 (scrittura verso PCI) 
	outputb(work, iBMCMD);
	inputb(iBMSTR, work);
	work &= 0xF9;
	outputb(work, iBMSTR);

	// comandi per il controllore ATA
	natb lba_0 = indse,
		lba_1 = indse >> 8,
		lba_2 = indse >> 16,
		lba_3 = indse >> 24;
	outputb(lba_0, iSNR);			
	outputb(lba_1, iCNL);
	outputb(lba_2, iCNH);
	natb hnd = (lba_3 & 0x0F) | 0xE0;
	outputb(hnd, iHND); 
	outputb(nn, iSCR);
	outputb(0x00, iDCR);
	outputb(0xCA, iCMD);			// comando di scrittura in DMA

	// avvio dell'operazione
	inputb(iBMCMD, work);
	work |= 0x01;
	outputb(work, iBMCMD);

	sem_wait(sincr);
}

extern "C" void c_driver_wdma()
{	natb work;
	inputb(iBMCMD, work);
	work &= 0xFE;
	outputb(work, iBMCMD);
	inputb(iBMSTR, work);
	inputb(iSTS, work);
	outputb(0x02,iDCR); 
	
	sem_signal(sincr);
}
//***************************************************************************************************
